#include <opencv2/opencv.hpp>
#include <iostream>
#include <string>
#include <vector>
#include <unistd.h>
#include <strings.h>

using namespace cv;
using namespace std;

 int main( int argc, char** argv )
 {
    int low_color1_a,low_color1_b,low_color1_c;
    int high_color1_a,high_color1_b,high_color1_c;
    int low_color2_a,low_color2_b,low_color2_c;
    int high_color2_a,high_color2_b,high_color2_c;
    char demo;

    cout << endl << endl << endl;
    cout << "-----------------------------------  Welcome to Beagleboard-xM Color Detector  -----------------------------------" << endl << endl;

    cout << "Press d if you want to use default colors (red,green), else press any other key: ";
    cin >> demo;

    if (demo == 'd')
    {
	 low_color1_a = 0;
         low_color1_b = 103;
     	 low_color1_c = 100;
	 high_color1_a = 10;
	 high_color1_b = 255;
	 high_color1_c = 255;
	 low_color2_a = 62;
         low_color2_b = 184;
         low_color2_c = 62;
         high_color2_a = 90;
         high_color2_b = 255;
         high_color2_c = 255;
    }else
    {
	//first color
    	cout << "Give a low threshold for the first color: (3 numbers: 0 103 100):" << endl;
    	cin >> low_color1_a;
    	cin >> low_color1_b;
    	cin >> low_color1_c;
	while ((low_color1_a<0) || (low_color1_a>255) || (low_color1_b<0) || (low_color1_b>255) || (low_color1_c<0) || (low_color1_c>255))
    	{
		cout << endl << "Wrong number(s) for color1! The range must be between 0-255"<< endl;
    		cout << "Give a low threshold for the first color: (3 numbers):"<< endl;
    		cin >> low_color1_a;
    		cin >> low_color1_b;
    		cin >> low_color1_c;
    	}

    	cout << "Give a high threshold for the first color: (3 numbers: 10 255 255):" << endl;
    	cin >> high_color1_a;
    	cin >> high_color1_b;
    	cin >> high_color1_c;
    	while ((high_color1_a<0) || (high_color1_a>255) || (high_color1_b<0) || (high_color1_b>255) || (high_color1_c<0) || (high_color1_c>255))
    	{
		cout << endl << "Wrong number(s) for color1! The range must be between 0-255"<< endl;
    		cout << "Give a high threshold for the first color: (3 numbers):"<< endl;
    		cin >> high_color1_a;
    		cin >> high_color1_b;
    		cin >> high_color1_c;
    	}

    	//second color
    	cout << "Give a low threshold for the second color: (3 numbers: 64 84 62):" << endl;
    	cin >> low_color2_a;
    	cin >> low_color2_b;
    	cin >> low_color2_c;
    	while ((low_color2_a<0) || (low_color2_a>255) || (low_color2_b<0) || (low_color2_b>255) || (low_color2_c<0) || (low_color2_c>255))
    	{
		cout << endl << "Wrong number(s) for color2! The range must be between 0-255"<< endl;
    		cout << "Give a low threshold for the second color: (3 numbers):"<< endl;
    		cin >> low_color2_a;
    		cin >> low_color2_b;
    		cin >> low_color2_c;
    	}

    	cout << "Give a high threshold for the second color: (3 numbers: 90 255 255):" << endl;
    	cin >> high_color2_a;
    	cin >> high_color2_b;
    	cin >> high_color2_c;
    	while ((high_color2_a<0) || (high_color2_a>255) || (high_color2_b<0) || (high_color2_b>255) || (high_color2_c<0) || (high_color2_c>255))
    	{
		cout << endl << "Wrong number(s) for color2! The range must be between 0-255"<< endl;
    		cout << "Give a high threshold for the second color: (3 numbers):"<< endl;
    		cin >> high_color2_a;
    		cin >> high_color2_b;
    		cin >> high_color2_c;
    	}
    }

    VideoCapture cap(0); //capture the video from web cam
    if ( !cap.isOpened() )  // if not success, exit program
    {
         cout << "Cannot open the web cam" << endl;
         return -1;
    }

    string name_img;
    char exit_loop;
    int global_color1=0, global_color2=0, counter_loop=1, flag=0;

    vector<Vec3f> circles_color1; // defines a vector with the circles with color1 identified
    vector<Vec3f> circles_color2; // defines a vector with the circles with color2 identified

    while (true)
    {
       	Mat imgOriginal;
	Mat hsv_image;

       	bool bSuccess = cap.read(imgOriginal); // read a new frame from video
        if (!bSuccess) //if not success, break loop
       	{
            cout << "Cannot read a frame from video stream" << endl;
            break;
       	}

	cvtColor(imgOriginal, hsv_image, COLOR_BGR2HSV); //Convert the captured frame from BGR to HSV

	// Threshold the HSV image, keep only the color1 pixels
	Mat color1_hue_image;
	inRange(hsv_image, Scalar(low_color1_a, low_color1_b, low_color1_c), Scalar(high_color1_a, high_color1_b, high_color1_c), color1_hue_image);

	// Combine the above two images
	GaussianBlur(color1_hue_image, color1_hue_image, Size(9, 9), 2, 2);

	// Threshold the HSV image, keep only the color2 pixels
	Mat color2_hue_image;
	inRange(hsv_image,Scalar(low_color2_a,low_color2_b,low_color2_c),Scalar(high_color2_a,high_color2_b,high_color2_c),color2_hue_image);

	//Combine the above two images
	GaussianBlur(color2_hue_image, color2_hue_image, Size(9, 9), 2, 2);

	if((circles_color1.empty()) && (circles_color2.empty()))
    	{
		HoughCircles(color1_hue_image, circles_color1, CV_HOUGH_GRADIENT, 1, color1_hue_image.rows/8, 100, 20, 0, 0);
		if (circles_color1.size() != 0){
			cout << "Found color1= !" << circles_color1.size() << endl;}

		HoughCircles(color2_hue_image, circles_color2, CV_HOUGH_GRADIENT, 1, color2_hue_image.rows/8, 100, 20, 0, 0);
		if (circles_color2.size() != 0){
			cout << "Found color2= !" << circles_color2.size() << endl;}

		global_color1 = global_color1 + circles_color1.size();
        	global_color2 = global_color2 + circles_color2.size();
	}else
	{
		HoughCircles(color1_hue_image, circles_color1, CV_HOUGH_GRADIENT, 1, color1_hue_image.rows/8, 100, 20, 0, 0);
		HoughCircles(color2_hue_image, circles_color2, CV_HOUGH_GRADIENT, 1, color2_hue_image.rows/8, 100, 20, 0, 0);
	}

	counter_loop++;

	if (counter_loop % 60 == 0)
	{
		cout << "Do you want to stop? (y/n): ";
		cin >> exit_loop;
		if (exit_loop == 'y')
		{
			flag = 1;
		}else
		{
			flag = 0;
		}
	}
	if (flag == 1)
	{
		break;
	}
    }

    cout << "The total number of the color1 balls is " << global_color1 << endl;
    cout << "The total number of the color2 balls is " << global_color2 << endl;
    cout << "The total number of the balls (color1 + color2) is " << global_color1 + global_color2 << endl;

    return 0;

}

